This script updates a dns record in your Cloudflare account to match 
your current public IP address.\
First it checks your IP address, and if it is different from the IP address in your 
Cloudflare dns record, updates the dns record in Cloudflare\
Before running this script you must login to Cloudflare and create a Token 
with the following Permissions:  
- Zone - Zone - Read  
- Zone - DNS - Edit    \
and the following Zone Resources:  
- Include - Specific zone - yourdomain.xxx")

These permissions are necessary to check the names and IDs of your dns records (Zone Read)\
and to change the IP address of a particular record (DNS Edit).\
Once run for the first time, if you want to be super secure, you can remove 
the Zone Read permission. This will not allow you to run --setup anymore, but
 you will still be able to run the script with all the other arguments.
  
You must also create an A record (xxx.yourdomain.xxx).\
This script only needs to be run once to setup your ddns updater.  
  
I created this script so that I could run it in a dedicated VM or CT in Proxmox,  so I have only ever run it as root.
The Cloudflare token is saved in clear in a json file that is readable by everyone,   
so whoever has access to the machine will be able to see the token.
In my setup, it is in a container with only root as user, so it is not a problem,   
but if your setup is different, please consider this security aspect.  
  
To install on recent Linux systems use pipx.\
On older systems you can use pip.\
I am assuming you are root, otherwise use `sudo` as necessary.  
  
On Debian or Ubuntu  
- `apt install pipx`

On Alpine Linux  
- `apk add pipx`  
  
  
Once installed:  
- `pipx ensurepath`  
- Logout and login again (or reboot)  
- `pipx install cloudflare-ddns-updater`  
  
To setup the program  
- `cloudflare-ddns-updater --setup`  
  
To change IP check interval  
- `cloudflare-ddns-updater --cron`  
  
To stop automatic ip update  
- `cloudflare-ddns-updater --stop`  
  
To resume automatic IP update  
- `cloudflare-ddns-updater --start`  
  
To remove all files created by the script  
- `cloudflare-ddns-updater --cleanup`  
  
To check the logs  
- `cat /var/log/ip_update.log`\n  
or   
- `tail -f /var/log/ip_update.log` if you want to follow in realtime  
  
To uninstall
    `cloudflare-ddns-updater --cleanup`
    `pipx uninstall cloudflare-ddns-updater`  
  

  
  
TODO  
- Try an installation not as root  
- Install as unique user and lockdown privileges  
- Option to always or never force ip update  
- --logs to change quantity of logs  
  
Changes:  
0.1.29 - improved ux \
       - added token verification\
       - moved constants to separate file\
       - implemented 3 tries for token input
       - implemented multiple tries for dns record choice\
